## sundials 3.1.1+dfsg

=== CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer:  Radu Serban @ LLNL
# ---------------------------------------------------------------
# LLNS Copyright Start
# Copyright (c) 2014, Lawrence Livermore National Security
# This work was performed under the auspices of the U.S. Department
# of Energy by Lawrence Livermore National Laboratory in part under
# Contract W-7405-Eng-48 and in part under Contract DE-AC52-07NA27344.
# Produced at the Lawrence Livermore National Laboratory.
# All rights reserved.
# For details, see the LICENSE file.
# LLNS Copyright End
# ---------------------------------------------------------------
# Top level CMakeLists.txt for SUNDIALS (for cmake build system)
# ---------------------------------------------------------------

# ---------------------------------------------------------------
# Initial commands
# ---------------------------------------------------------------

# Require a fairly recent cmake version
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.1)

# Set CMake policy to allow examples to build
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

# Project SUNDIALS (initially only C supported)
# sets PROJECT_SOURCE_DIR and PROJECT_BINARY_DIR variables
PROJECT(sundials C)

# Set some variables with info on the SUNDIALS project
SET(PACKAGE_BUGREPORT "woodward6@llnl.gov")
SET(PACKAGE_NAME "SUNDIALS")
SET(PACKAGE_STRING "SUNDIALS 3.1.1")
SET(PACKAGE_TARNAME "sundials")

# set SUNDIALS version numbers 
# (use "" for the version label if none is needed)
SET(PACKAGE_VERSION_MAJOR "3")
SET(PACKAGE_VERSION_MINOR "1")
SET(PACKAGE_VERSION_PATCH "1")
SET(PACKAGE_VERSION_LABEL "")

IF(PACKAGE_VERSION_LABEL)
  SET(PACKAGE_VERSION "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}-${PACKAGE_VERSION_LABEL}")
ELSE()
  SET(PACKAGE_VERSION "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}")
ENDIF()

#
SET_PROPERTY(GLOBAL PROPERTY USE_FOLDERS ON)

# Prohibit in-source build
IF("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  MESSAGE(FATAL_ERROR "In-source build prohibited.")
ENDIF("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")

# Hide some cache variables
MARK_AS_ADVANCED(EXECUTABLE_OUTPUT_PATH LIBRARY_OUTPUT_PATH)

# Always show the C compiler and flags
MARK_AS_ADVANCED(CLEAR
  CMAKE_C_COMPILER
  CMAKE_C_FLAGS)

# Specify the VERSION and SOVERSION for shared libraries

SET(arkodelib_VERSION "2.1.1")
SET(arkodelib_SOVERSION "2")

SET(cvodelib_VERSION "3.1.1")
SET(cvodelib_SOVERSION "3")

SET(cvodeslib_VERSION "3.1.1")
SET(cvodeslib_SOVERSION "3")

SET(idalib_VERSION "3.1.1")
SET(idalib_SOVERSION "3")

SET(idaslib_VERSION "2.1.0")
SET(idaslib_SOVERSION "2")

SET(kinsollib_VERSION "3.1.1")
SET(kinsollib_SOVERSION "3")

SET(cpodeslib_VERSION "0.0.0")
SET(cpodeslib_SOVERSION "0")

SET(nveclib_VERSION "3.1.1")
SET(nveclib_SOVERSION "3")

SET(sunmatrixlib_VERSION "1.1.1")
SET(sunmatrixlib_SOVERSION "1")

SET(sunlinsollib_VERSION "1.1.1")
SET(sunlinsollib_SOVERSION "1")

# Specify the location of additional CMAKE modules
SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/config)

# ---------------------------------------------------------------
# MACRO definitions
# ---------------------------------------------------------------
INCLUDE(SundialsCMakeMacros)

# ---------------------------------------------------------------
# Check for deprecated SUNDIALS CMake options/variables
# ---------------------------------------------------------------
INCLUDE(SundialsDeprecated)

# ---------------------------------------------------------------
# Which modules to build?
# ---------------------------------------------------------------

# For each SUNDIALS solver available (i.e. for which we have the
# sources), give the user the option of enabling/disabling it.

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/arkode")
  OPTION(BUILD_ARKODE "Build the ARKODE library" ON)
ELSE()
  SET(BUILD_ARKODE OFF)
ENDIF()

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cvode")
  OPTION(BUILD_CVODE "Build the CVODE library" ON)
ELSE()
  SET(BUILD_CVODE OFF)
ENDIF()

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cvodes")
  OPTION(BUILD_CVODES "Build the CVODES library" ON)
ELSE()
  SET(BUILD_CVODES OFF)
ENDIF()

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/ida")
  OPTION(BUILD_IDA "Build the IDA library" ON)
ELSE()
  SET(BUILD_IDA OFF)
ENDIF()

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/idas")
  OPTION(BUILD_IDAS "Build the IDAS library" ON)
ELSE()
  SET(BUILD_IDAS OFF)
ENDIF()

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/kinsol")
  OPTION(BUILD_KINSOL "Build the KINSOL library" ON)
ELSE()
  SET(BUILD_KINSOL OFF)
ENDIF()

# CPODES is always OFF for now.  (commented out for Release); ToDo: better way to do this?
#IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cpodes")
#  OPTION(BUILD_CPODES  "Build the CPODES library"  OFF)
#ELSE()
#  SET(BUILD_CPODES OFF)
#ENDIF()

# ---------------------------------------------------------------
# xSDK specific options
# ---------------------------------------------------------------
INCLUDE(SundialsXSDK)

# ---------------------------------------------------------------
# Build specific C flags
# ---------------------------------------------------------------

# Hide all build type specific flags
MARK_AS_ADVANCED(FORCE
  CMAKE_C_FLAGS_DEBUG
  CMAKE_C_FLAGS_MINSIZEREL
  CMAKE_C_FLAGS_RELEASE
  CMAKE_C_FLAGS_RELWITHDEBINFO)

# Only show flags for the current build type it is set
# NOTE: Build specific flags are appended those in CMAKE_C_FLAGS
IF(CMAKE_BUILD_TYPE)
  IF(CMAKE_BUILD_TYPE MATCHES "Debug")
    MESSAGE("Appending C debug flags")
    MARK_AS_ADVANCED(CLEAR CMAKE_C_FLAGS_DEBUG)
  ELSEIF(CMAKE_BUILD_TYPE MATCHES "MinSizeRel")
    MESSAGE("Appending C min size release flags")
    MARK_AS_ADVANCED(CLEAR CMAKE_C_FLAGS_MINSIZEREL)
  ELSEIF(CMAKE_BUILD_TYPE MATCHES "Release")
    MESSAGE("Appending C release flags")
    MARK_AS_ADVANCED(CLEAR CMAKE_C_FLAGS_RELEASE)
  ELSEIF(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
    MESSAGE("Appending C release with debug info flags")
    MARK_AS_ADVANCED(CLEAR CMAKE_C_FLAGS_RELWITHDEBINFO)
  ENDIF()
ENDIF()

# ---------------------------------------------------------------
# Option to specify precision (realtype)
# ---------------------------------------------------------------

SET(DOCSTR "single, double, or extended")
SHOW_VARIABLE(SUNDIALS_PRECISION STRING "${DOCSTR}" "double")

# prepare substitution variable PRECISION_LEVEL for sundials_config.h
STRING(TOUPPER ${SUNDIALS_PRECISION} SUNDIALS_PRECISION)
SET(PRECISION_LEVEL "#define SUNDIALS_${SUNDIALS_PRECISION}_PRECISION 1")

# prepare substitution variable FPRECISION_LEVEL for sundials_fconfig.h
IF(SUNDIALS_PRECISION MATCHES "SINGLE")
  SET(FPRECISION_LEVEL "4")
ENDIF(SUNDIALS_PRECISION MATCHES "SINGLE")
IF(SUNDIALS_PRECISION MATCHES "DOUBLE")
  SET(FPRECISION_LEVEL "8")
ENDIF(SUNDIALS_PRECISION MATCHES "DOUBLE")
IF(SUNDIALS_PRECISION MATCHES "EXTENDED")
  SET(FPRECISION_LEVEL "16")
ENDIF(SUNDIALS_PRECISION MATCHES "EXTENDED")

# ---------------------------------------------------------------
# Option to specify index type
# ---------------------------------------------------------------

SET(DOCSTR "Signed 64-bit (int64_t) or signed 32-bit (int32_t) integer")
SHOW_VARIABLE(SUNDIALS_INDEX_TYPE STRING "${DOCSTR}" "int64_t")

# prepare substitution variable INDEX_TYPE for sundials_config.h
STRING(TOUPPER ${SUNDIALS_INDEX_TYPE} SUNDIALS_INDEX_TYPE)
SET(INDEX_TYPE "#define SUNDIALS_${SUNDIALS_INDEX_TYPE} 1")

# prepare substitution variable FINDEX_TYPE for sundials_fconfig.h
IF(SUNDIALS_INDEX_TYPE MATCHES "INT32_T")
  SET(FINDEX_TYPE "4")
ENDIF(SUNDIALS_INDEX_TYPE MATCHES "INT32_T")
IF(SUNDIALS_INDEX_TYPE MATCHES "INT64_T")
  SET(FINDEX_TYPE "8")
ENDIF(SUNDIALS_INDEX_TYPE MATCHES "INT64_T")

# ---------------------------------------------------------------
# Enable Fortran interface?
# ---------------------------------------------------------------

# Fortran interface is disabled by default
SET(DOCSTR "Enable Fortran-C support")
SHOW_VARIABLE(FCMIX_ENABLE BOOL "${DOCSTR}" OFF)

# Check that at least one solver with a Fortran interface is built
IF(NOT BUILD_ARKODE AND NOT BUILD_CVODE AND NOT BUILD_IDA AND NOT BUILD_KINSOL)
  IF(FCMIX_ENABLE)
    PRINT_WARNING("Enabled packages do not support Fortran" "Disabling FCMIX")
    FORCE_VARIABLE(FCMIX_ENABLE BOOL "${DOCSTR}" OFF)
  ENDIF()
  HIDE_VARIABLE(FCMIX_ENABLE)
ENDIF()

# ---------------------------------------------------------------
# Options to build static and/or shared libraries
# ---------------------------------------------------------------

OPTION(BUILD_STATIC_LIBS "Build static libraries" ON)
OPTION(BUILD_SHARED_LIBS "Build shared libraries" ON)

# Prepare substitution variable SUNDIALS_EXPORT for sundials_config.h
# When building shared SUNDIALS libraries under Windows, use
#      #define SUNDIALS_EXPORT __declspec(dllexport)
# When linking to shared SUNDIALS libraries under Windows, use
#      #define SUNDIALS_EXPORT __declspec(dllimport)
# In all other cases (other platforms or static libraries
# under Windows), the SUNDIALS_EXPORT macro is empty

IF(BUILD_SHARED_LIBS AND WIN32)
  SET(SUNDIALS_EXPORT
    "#ifdef BUILD_SUNDIALS_LIBRARY
#define SUNDIALS_EXPORT __declspec(dllexport)
#else
#define SUNDIALS_EXPORT __declspec(dllimport)
#endif")
ELSE(BUILD_SHARED_LIBS AND WIN32)
  SET(SUNDIALS_EXPORT "#define SUNDIALS_EXPORT")
ENDIF(BUILD_SHARED_LIBS AND WIN32)

# Make sure we build at least one type of libraries
IF(NOT BUILD_STATIC_LIBS AND NOT BUILD_SHARED_LIBS)
  PRINT_WARNING("Both static and shared library generation were disabled"
                "Building static libraries was re-enabled")
  FORCE_VARIABLE(BUILD_STATIC_LIBS BOOL "Build static libraries" ON)
ENDIF(NOT BUILD_STATIC_LIBS AND NOT BUILD_SHARED_LIBS)

# ---------------------------------------------------------------
# Option to use the generic math libraries (UNIX only)
# ---------------------------------------------------------------

IF(UNIX)
  OPTION(USE_GENERIC_MATH "Use generic (std-c) math libraries" ON)
  IF(USE_GENERIC_MATH)
    # executables will be linked against -lm
    SET(EXTRA_LINK_LIBS -lm)
    # prepare substitution variable for sundials_config.h
    SET(SUNDIALS_USE_GENERIC_MATH TRUE)
  ENDIF(USE_GENERIC_MATH)
ENDIF(UNIX)

## clock-monotonic, see if we need to link with rt
include(CheckSymbolExists)
set(CMAKE_REQUIRED_LIBRARIES_SAVE ${CMAKE_REQUIRED_LIBRARIES})
set(CMAKE_REQUIRED_LIBRARIES rt)
CHECK_SYMBOL_EXISTS(_POSIX_TIMERS "unistd.h;time.h" SUNDIALS_POSIX_TIMERS)
set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES_SAVE})
if(SUNDIALS_POSIX_TIMERS)
  find_library(SUNDIALS_RT_LIBRARY NAMES rt)
  mark_as_advanced(SUNDIALS_RT_LIBRARY)
  if(SUNDIALS_RT_LIBRARY)
    # sundials_config.h symbol
    SET(SUNDIALS_HAVE_POSIX_TIMERS TRUE)
    set(EXTRA_LINK_LIBS ${EXTRA_LINK_LIBS} ${SUNDIALS_RT_LIBRARY})
  endif()
endif()


# ===============================================================
# Options for Parallelism
# ===============================================================

# ---------------------------------------------------------------
# Enable MPI support?
# ---------------------------------------------------------------
OPTION(MPI_ENABLE "Enable MPI support" OFF)

# ---------------------------------------------------------------
# Enable OpenMP support?
# ---------------------------------------------------------------
OPTION(OPENMP_ENABLE "Enable OpenMP support" OFF)

# ---------------------------------------------------------------
# Enable Pthread support?
# ---------------------------------------------------------------
OPTION(PTHREAD_ENABLE "Enable Pthreads support" OFF)

# -------------------------------------------------------------
# Enable CUDA support?
# -------------------------------------------------------------
OPTION(CUDA_ENABLE "Enable CUDA support" OFF)

=== examples/cvode/serial/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Radu Serban @ LLNL
#                David J. Gardner @ LLNL
# ---------------------------------------------------------------
# LLNS Copyright Start
# Copyright (c) 2014, Lawrence Livermore National Security
# This work was performed under the auspices of the U.S. Department
# of Energy by Lawrence Livermore National Laboratory in part under
# Contract W-7405-Eng-48 and in part under Contract DE-AC52-07NA27344.
# Produced at the Lawrence Livermore National Laboratory.
# All rights reserved.
# For details, see the LICENSE file.
# LLNS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for CVODE serial examples
# ---------------------------------------------------------------

# Example lists are tuples "name\;type" where the type is
# 'develop' for examples excluded from 'make test' in releases

# Examples using SUNDIALS linear solvers
SET(CVODE_examples
  "cvAdvDiff_bnd\;develop"
  "cvDirectDemo_ls\;develop"
  "cvDiurnal_kry_bp\;develop"
  "cvDiurnal_kry\;develop"
  "cvKrylovDemo_ls\;develop"
  "cvKrylovDemo_prec\;develop"
  "cvRoberts_dns\;"
  "cvRoberts_dns_uw\;develop"
  #cvAdvDiffReac_kry\;develop"
  )

# Examples using LAPACK linear solvers
SET(CVODE_examples_BL
  "cvAdvDiff_bndL\;develop"
  "cvRoberts_dnsL\;develop"
  )

# Examples using KLU linear solver
SET(CVODE_examples_KLU
  "cvRoberts_klu\;develop"
  )

# Examples using SuperLU_MT linear solver
SET(CVODE_examples_SUPERLUMT
  "cvRoberts_sps\;develop"
  )

# Specify libraries to link against (through the target that was used to 
# generate them) based on the value of the variable LINK_LIBRARY_TYPE
IF(LINK_LIBRARY_TYPE MATCHES "static")
  SET(CVODE_LIB sundials_cvode_static)
  SET(NVECS_LIB sundials_nvecserial_static)
ELSE()
  SET(CVODE_LIB sundials_cvode_shared)
  SET(NVECS_LIB sundials_nvecserial_shared)
ENDIF()

# Set-up linker flags and link libraries
SET(SUNDIALS_LIBS ${CVODE_LIB} ${NVECS_LIB} ${EXTRA_LINK_LIBS})


# Add the build and install targets for each example
FOREACH(example_tuple ${CVODE_examples})

  # parse the example tuple
  LIST(GET example_tuple 0 example)
  LIST(GET example_tuple 1 example_type)

  # example source files
  ADD_EXECUTABLE(${example} ${example}.c)

  SET_TARGET_PROPERTIES(${example} PROPERTIES FOLDER "Examples")

  # add example to regression tests
  SUNDIALS_ADD_TEST(${example} ${example}
    ANSWER_DIR ${CMAKE_CURRENT_SOURCE_DIR}
    ANSWER_FILE ${example}.out
    EXAMPLE_TYPE ${example_type})

  # libraries to link against
  TARGET_LINK_LIBRARIES(${example} ${SUNDIALS_LIBS})

  # install example source and out files
  IF(EXAMPLES_INSTALL)
    INSTALL(FILES ${example}.c ${example}.out
      DESTINATION ${EXAMPLES_INSTALL_PATH}/cvode/serial)
  ENDIF()

ENDFOREACH(example_tuple ${CVODE_examples})


# Add the build and install targets for each LAPACK example (if needed)
IF(LAPACK_FOUND)

  # Sundials LAPACK linear solver modules
  IF(LINK_LIBRARY_TYPE MATCHES "static")
    SET(SUNLINSOLLAPACK_LIBS
      sundials_sunlinsollapackband_static
      sundials_sunlinsollapackdense_static)
  ELSE()
    SET(SUNLINSOLLAPACK_LIBS
      sundials_sunlinsollapackband_shared
      sundials_sunlinsollapackdense_shared)
  ENDIF()

  # LAPACK libraries
  LIST(APPEND SUNLINSOLLAPACK_LIBS ${LAPACK_LIBRARIES})

  # BLAS libraries
  IF(BLAS_FOUND)
    LIST(APPEND SUNLINSOLLAPACK_LIBS ${BLAS_LIBRARIES})
  ENDIF(BLAS_FOUND)

  FOREACH(example_tuple ${CVODE_examples_BL})

    # parse the example tuple
    LIST(GET example_tuple 0 example)
    LIST(GET example_tuple 1 example_type)

    # example source files
    ADD_EXECUTABLE(${example} ${example}.c)

    SET_TARGET_PROPERTIES(${example} PROPERTIES FOLDER "Examples")

    # add example to regression tests
    SUNDIALS_ADD_TEST(${example} ${example}
      ANSWER_DIR ${CMAKE_CURRENT_SOURCE_DIR}
      ANSWER_FILE ${example}.out
      EXAMPLE_TYPE ${example_type})

    # libraries to link against
    TARGET_LINK_LIBRARIES(${example} ${SUNDIALS_LIBS} ${SUNLINSOLLAPACK_LIBS})

    # install example source and out files
    IF(EXAMPLES_INSTALL)
      INSTALL(FILES ${example}.c ${example}.out
        DESTINATION ${EXAMPLES_INSTALL_PATH}/cvode/serial)
    ENDIF()

  ENDFOREACH(example_tuple ${CVODE_examples_BL})

ENDIF(LAPACK_FOUND)


# Add the build and install targets for each KLU example (if needed)
IF(KLU_FOUND)

  # Sundials KLU linear solver module
  IF(LINK_LIBRARY_TYPE MATCHES "static")
    SET(SUNLINSOLKLU_LIBS sundials_sunlinsolklu_static)
  ELSE()
    SET(SUNLINSOLKLU_LIBS sundials_sunlinsolklu_shared)
  ENDIF()

  # KLU libraries
  LIST(APPEND SUNLINSOLKLU_LIBS ${KLU_LIBRARIES})

  FOREACH(example_tuple ${CVODE_examples_KLU})

    # parse the example tuple
    LIST(GET example_tuple 0 example)
    LIST(GET example_tuple 1 example_type)

    # example source files
    ADD_EXECUTABLE(${example} ${example}.c)

    SET_TARGET_PROPERTIES(${example} PROPERTIES FOLDER "Examples")

    # add example to regression tests
    SUNDIALS_ADD_TEST(${example} ${example}
      ANSWER_DIR ${CMAKE_CURRENT_SOURCE_DIR}
      ANSWER_FILE ${example}.out
      EXAMPLE_TYPE ${example_type})

    # libraries to link against
    TARGET_LINK_LIBRARIES(${example} ${SUNDIALS_LIBS} ${SUNLINSOLKLU_LIBS})

    # install example source and out files
    IF(EXAMPLES_INSTALL)
      INSTALL(FILES ${example}.c ${example}.out
        DESTINATION ${EXAMPLES_INSTALL_PATH}/cvode/serial)
    ENDIF()

  ENDFOREACH(example_tuple ${CVODE_examples_KLU})

ENDIF(KLU_FOUND)


# Add the build and install targets for each SuperLU_MT example (if needed)
IF(SUPERLUMT_FOUND)

  # Sundials SuperLU_MT linear solver module
  IF(LINK_LIBRARY_TYPE MATCHES "static")
    SET(SUNLINSOLSLUMT_LIBS sundials_sunlinsolsuperlumt_static)
  ELSE()
    SET(SUNLINSOLSLUMT_LIBS sundials_sunlinsolsuperlumt_shared)
  ENDIF()

  # SuperLU_MT libraries
  LIST(APPEND SUNLINSOLSLUMT_LIBS ${SUPERLUMT_LIBRARIES})

  # BLAS libraries
  IF(BLAS_FOUND)
    LIST(APPEND SUNLINSOLSLUMT_LIBS ${BLAS_LIBRARIES})
  ENDIF(BLAS_FOUND)

  FOREACH(example_tuple ${CVODE_examples_SUPERLUMT})

    # parse the example tuple
    LIST(GET example_tuple 0 example)
    LIST(GET example_tuple 1 example_type)

    # example source files
    ADD_EXECUTABLE(${example} ${example}.c)

    SET_TARGET_PROPERTIES(${example} PROPERTIES FOLDER "Examples")

    # add example to regression tests
    SUNDIALS_ADD_TEST(${example} ${example}
      ANSWER_DIR ${CMAKE_CURRENT_SOURCE_DIR}
      ANSWER_FILE ${example}.out
      EXAMPLE_TYPE ${example_type})

    # libraries to link against
    TARGET_LINK_LIBRARIES(${example} ${SUNDIALS_LIBS} ${SUNLINSOLSLUMT_LIBS})

    # install example source and out files
    IF(EXAMPLES_INSTALL)
      INSTALL(FILES ${example}.c ${example}.out
        DESTINATION ${EXAMPLES_INSTALL_PATH}/cvode/serial)
    ENDIF()

  ENDFOREACH(example_tuple ${CVODE_examples_SUPERLUMT})

ENDIF(SUPERLUMT_FOUND)


# create Makfile and CMakeLists.txt for examples
IF(EXAMPLES_INSTALL)

  # Install the README file
  INSTALL(FILES README DESTINATION ${EXAMPLES_INSTALL_PATH}/cvode/serial)

  # Prepare substitution variables for Makefile and/or CMakeLists templates
  SET(SOLVER "CVODE")
  SET(SOLVER_LIB "sundials_cvode")

  EXAMPLES2STRING(CVODE_examples EXAMPLES)

  IF(LAPACK_FOUND)
    EXAMPLES2STRING(CVODE_examples_BL EXAMPLES_BL)
  ELSE()
    SET(EXAMPLES_BL "")
  ENDIF()

  IF(KLU_FOUND)
    EXAMPLES2STRING(CVODE_examples_KLU EXAMPLES_KLU)
  ELSE()
    SET(EXAMPLES_KLU "")
  ENDIF()

  IF(SUPERLUMT_FOUND)
    EXAMPLES2STRING(CVODE_examples_SUPERLUMT EXAMPLES_SLUMT)
  ELSE()
    SET(EXAMPLES_SLUMT "")
  ENDIF()

  # Regardless of the platform we're on, we will generate and install 
  # CMakeLists.txt file for building the examples. This file  can then 
  # be used as a template for the user's own programs.

  # generate CMakelists.txt in the binary directory
  CONFIGURE_FILE(
    ${PROJECT_SOURCE_DIR}/examples/templates/cmakelists_serial_C_ex.in
    ${PROJECT_BINARY_DIR}/examples/cvode/serial/CMakeLists.txt
    @ONLY
    )

  # install CMakelists.txt
  INSTALL(
    FILES ${PROJECT_BINARY_DIR}/examples/cvode/serial/CMakeLists.txt
    DESTINATION ${EXAMPLES_INSTALL_PATH}/cvode/serial 
    )

  # On UNIX-type platforms, we also  generate and install a makefile for 
  # building the examples. This makefile can then be used as a template 
  # for the user's own programs.

  IF(UNIX)
    # generate Makefile and place it in the binary dir
    CONFIGURE_FILE(
      ${PROJECT_SOURCE_DIR}/examples/templates/makefile_serial_C_ex.in
      ${PROJECT_BINARY_DIR}/examples/cvode/serial/Makefile_ex
      @ONLY
      )
    # install the configured Makefile_ex as Makefile
    INSTALL(
      FILES ${PROJECT_BINARY_DIR}/examples/cvode/serial/Makefile_ex 
      DESTINATION ${EXAMPLES_INSTALL_PATH}/cvode/serial 
      RENAME Makefile
      )
  ENDIF(UNIX)

  # add test_install target
  SUNDIALS_ADD_TEST_INSTALL(cvode cvRoberts_dns
    EXAMPLE_DIR ${EXAMPLES_INSTALL_PATH}/cvode/serial)

ENDIF(EXAMPLES_INSTALL)

=== debian/changelog ===
sundials (3.1.1+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Set OMPI_MCA_rmaps_base_oversubscribe=1 when running the testsuite, this
    prevents FTBFS when there are not enough CPUs. Thanks to Graham Inggs for
    the hint. (Closes: #910352)

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 15 Nov 2018 12:35:10 +0100

sundials (3.1.1+dfsg-1) unstable; urgency=medium

  * New upstream release: 3.1.1
  * Add lintian overrides for differing sonames
  * SONAME bumps for all the libraries
  * New sub-libraries:
    - libsundials-sunlinsol1
    - libsundials-sunmatrix1
  * Removed libsundials-doc; examples are now shipped in libsundials-dev

 -- Dima Kogan <dkogan@debian.org>  Sat, 16 Jun 2018 01:05:45 -0700

=== debian/control ===
Source: sundials
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>,
           James Tocknell <aragilar@gmail.com>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 10),
               pkg-config,
               chrpath,
               cmake,
               python,
               gfortran,
               mpi-default-dev,
               libblas-dev | libblas.so,
               liblapack-dev | liblapack.so,
               petsc-dev, libsuitesparse-dev, libhypre-dev
Standards-Version: 4.1.0
Vcs-Browser: https://salsa.debian.org/science-team/sundials
Vcs-Git: https://salsa.debian.org/science-team/sundials.git
Homepage: http://www.llnl.gov/CASC/sundials/

Package: libsundials-arkode2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 This package contains the library for differential equation (ODE) system
 solvers from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers). ARKODE is a solver for multi-rate ODE systems (initial value
 problems) given in explicit form M*dy/dt = f(t,y)

Package: libsundials-cvode3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ordinary differential equation solver (SUNDIALS library)
 This package contains the library for ordinary differential equation (ODE)
 system solvers from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic
 equation Solvers). CVODE is a solver for stiff and nonstiff ODE systems
 (initial value problem) given in explicit form dy/dt = f(t,y).

Package: libsundials-cvodes3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ODE solver with sensistivity analysis (SUNDIALS library)
 This package contains the library for ordinary differential equation (ODE)
 system solver with sensistivity analysis capabilities from SUNDIALS (SUite of
 Nonlinear and DIfferential/ALgebraic equation Solvers). CVODES is a solver for
 stiff and nonstiff ODE systems (initial value problem) given in explicit form
 y' = f(t,y,p) with sensitivity analysis capabilities (both forward and adjoint
 modes).

Package: libsundials-ida3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential-algebraic system solver (SUNDIALS library)
 This package contains the library for differential-algebraic system (IDA)
 solver from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).

Package: libsundials-idas2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: IDA solver with sensitivity capabilities (SUNDIALS library)
 This package contains the library for differential-algebraic system with
 Sensitivity capabilities (IDAS) solver from SUNDIALS (SUite of Nonlinear and
 DIfferential/ALgebraic equation Solvers).

Package: libsundials-kinsol3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: KINSOL solver (SUNDIALS library)
 This package contain the library for KINSOL (nonlinear algebraic systems)
 system solver from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic
 equation Solvers).

Package: libsundials-nvecserial3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Non-parallel vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the serial flavor of the library.

Package: libsundials-nvecparallel-mpi3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mpi-default-bin
Description: MPI vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the MPI parallel flavor of the library.

Package: libsundials-nvecparallel-pthread3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Pthread vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the pthread-based parallel flavor of the library.

Package: libsundials-nvecparallel-openmp3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: OpenMP vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the OpenMP-based parallel flavor of the library.

Package: libsundials-nvecparallel-hypre3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: HYPRE vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the HYPRE-based parallel flavor of the library.

Package: libsundials-nvecparallel-petsc3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: PETSc vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the PETSc-based parallel flavor of the library.

Package: libsundials-sunlinsol1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 Auxiliary solvers used by the SUNDIALS library.

Package: libsundials-sunmatrix1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 Auxiliary solvers used by the SUNDIALS library.

Package: libsundials-dev
Architecture: any
Section: libdevel
Depends: libsundials-arkode2              (= ${binary:Version}),
         libsundials-cvode3               (= ${binary:Version}),
         libsundials-cvodes3              (= ${binary:Version}),
         libsundials-ida3                 (= ${binary:Version}),
         libsundials-idas2                (= ${binary:Version}),
         libsundials-kinsol3              (= ${binary:Version}),
         libsundials-nvecserial3          (= ${binary:Version}),
         libsundials-nvecparallel-mpi3    (= ${binary:Version}),
         libsundials-nvecparallel-pthread3(= ${binary:Version}),
         libsundials-nvecparallel-openmp3 (= ${binary:Version}),
         libsundials-nvecparallel-hypre3  (= ${binary:Version}),
         libsundials-nvecparallel-petsc3  (= ${binary:Version}),
         libsundials-sunlinsol1           (= ${binary:Version}),
         libsundials-sunmatrix1           (= ${binary:Version}),
         cmake, mpi-default-dev, libhypre-dev, petsc-dev, gfortran, pkg-config,
         ${misc:Depends}
Breaks: libsundials-serial-dev
Replaces: libsundials-serial-dev
Description: Package providing everything for SUNDIALS dev work
 This package contains all development files necessary to build applications
 using SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers). All examples and documentation links live in this package as well.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

include /usr/share/dpkg/architecture.mk

# We only need two libraries to build and use libhypre, but apparently the cmake
# code to detect that we do indeed have libhypre requires more, so I add them
# here as well
HYPRE_LIBS_FOR_DETECTION := -lHYPRE -lHYPRE_IJ_mv -lHYPRE_utilities
HYPRE_LIBS_FOR_BUILD     := -lHYPRE_parcsr_mv -lHYPRE_seq_mv


extra_flags += \
	-DCMAKE_Fortran_COMPILER=gfortran \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DBUILD_STATIC_LIBS:BOOL=ON \
	-DFCMIX_ENABLE:BOOL=ON \
	-DMPI_ENABLE:BOOL=ON \
	\
	-DSUNDIALS_INDEX_TYPE=int32_t \
	-DLAPACK_ENABLE:BOOL=ON \
	\
	-DEXAMPLES_ENABLE_C:BOOL=ON \
	-DEXAMPLES_ENABLE_CXX:BOOL=ON \
	-DEXAMPLES_ENABLE_F77:BOOL=ON \
	-DEXAMPLES_INSTALL:BOOL=ON \
	\
	-DOPENMP_ENABLE:BOOL=ON \
	-DPTHREAD_ENABLE:BOOL=ON \
	\
	-DKLU_ENABLE:BOOL=ON \
	-DKLU_INCLUDE_DIR=/usr/include/suitesparse \
	-DKLU_LIBRARY_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	\
	-DPETSC_ENABLE:BOOL=ON \
	\
	-DHYPRE_ENABLE:BOOL=ON \
	-DHYPRE_INCLUDE_DIR=/usr/include/hypre \
	-DHYPRE_LIBRARY='$(HYPRE_LIBS_FOR_DETECTION) $(HYPRE_LIBS_FOR_BUILD)'



# Debian doesn't ship superlu-mt currently, so I turn off this support
extra_flags += -DSUPERLUMT_ENABLE:BOOL=OFF


BUILDDIR = $(CURDIR)/debian/build


%:
	dh $@ --buildsystem=cmake  --builddirectory=$(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

# Hack from https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=839387
# The OpenMPI variable prevents FTBFS when there are not enough CPUs (see #910352 and #849974)
override_dh_auto_test:
	$(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),true,(cd debian/build; OMPI_MCA_rmaps_base_oversubscribe=1 ../nofakeroot ctest))

override_dh_auto_install:
	dh_auto_install
# I strip out all the RPATH/RUNPATH tags from my shared objects. These all point
# to libraries that actually live in standard locations, so the tags are not
# needed
	find debian/tmp/ -name '*.so' -o -name '*.so.*' -exec chrpath -d '{}' \;

override_dh_compress:
	dh_compress -Xexamples/

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR)
